package com.ema.admin.modules.system.controller;

import cn.hutool.core.collection.CollUtil;
import com.mybatisflex.core.paginate.Page;
import com.ema.admin.modules.system.converter.SysRoleConverter;
import com.ema.admin.modules.system.entity.SysRole;
import com.ema.admin.modules.system.service.SysMenuService;
import com.ema.admin.modules.system.service.SysRoleService;
import com.ema.admin.modules.system.vo.SysMenuVo;
import com.ema.admin.modules.system.vo.SysRoleInfoVo;
import com.ema.admin.modules.system.vo.SysRoleQueryVo;
import com.ema.admin.modules.system.vo.SysRoleSaveVo;
import com.ema.common.domain.enums.BooleanEnum;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 系统角色信息表 控制层。
 *
 * @author LIJIAN
 * @since 2026-03-23
 */
@RestController
@Api(tags = "系统角色信息表接口")
@RequestMapping("/sysRole")
public class SysRoleController {

    @Autowired
    private SysRoleService sysRoleService;
    @Autowired
    private SysMenuService sysMenuService;
    @Autowired
    private SysRoleConverter sysRoleConverter;

    /**
     * 添加系统角色信息表。
     *
     * @param saveVo 系统角色信息表
     * @return {@code true} 添加成功，{@code false} 添加失败
     */
    @PostMapping("save")
    @ApiOperation("保存系统角色信息表")
    public boolean save(@RequestBody @ApiParam("系统角色信息表") SysRoleSaveVo saveVo) {
        SysRole sysRole = sysRoleConverter.toSysRole(saveVo);
        boolean save = sysRoleService.save(sysRole);
        if(save && CollUtil.isNotEmpty(saveVo.getMenuIds())){
            sysRoleService.assignMenusToRole(sysRole.getId(),saveVo.getMenuIds());
        }
        return save;
    }

    /**
     * 根据主键删除系统角色信息表。
     *
     * @param id 主键
     * @return {@code true} 删除成功，{@code false} 删除失败
     */
    @DeleteMapping("remove/{id}")
    @ApiOperation("根据主键系统角色信息表")
    public boolean remove(@PathVariable @ApiParam("系统角色信息表主键") String id) {
        return sysRoleService.removeById(id);
    }

    /**
     * 根据主键更新系统角色信息表。
     *
     * @param sysRole 系统角色信息表
     * @return {@code true} 更新成功，{@code false} 更新失败
     */
    @PutMapping("update")
    @ApiOperation("根据主键更新系统角色信息表")
    public boolean update(@RequestBody @ApiParam("系统角色信息表主键") SysRoleSaveVo sysRole) {
        if(CollUtil.isNotEmpty(sysRole.getMenuIds())){
            sysRoleService.assignMenusToRole(sysRole.getId(),sysRole.getMenuIds());
        }
        return sysRoleService.updateById(sysRoleConverter.toSysRole(sysRole));
    }

    /**
     * 查询所有系统角色信息表。
     *
     * @return 所有数据
     */
    @GetMapping("list")
    @ApiOperation("查询所有系统角色信息表")
    public List<SysRole> list() {
        return sysRoleService.list();
    }

    /**
     * 根据系统角色信息表主键获取详细信息。
     *
     * @param id 系统角色信息表主键
     * @return 系统角色信息表详情
     */
    @GetMapping("getInfo/{id}")
    @ApiOperation("根据主键获取系统角色信息表")
    public SysRoleInfoVo getInfo(@PathVariable @ApiParam("系统角色信息表主键") String id) {
        SysRole sysRole = sysRoleService.getById(id);
        List<SysMenuVo> menuTree = sysMenuService.getTree(BooleanEnum.TRUE.getValue(), id);
        return sysRoleConverter.toSysRoleInfoVo(sysRole, menuTree);
    }

    /**
     * 分页查询系统角色信息表（带条件）。
     *
     * @param queryVo 查询条件
     * @return 分页对象
     */
    @PostMapping("page")
    @ApiOperation("分页查询系统角色信息表（带条件）")
    public Page<SysRole> page(@RequestBody @ApiParam("查询条件") SysRoleQueryVo queryVo) {
        return sysRoleService.page(queryVo);
    }

}
